MicroBinder = CreateFrame("Frame")

function ScaleEverything:CreateEditBox(parent, withButton)
	local iterator = 0
	repeat
		iterator = iterator + 1
	until(not _G["Editbox"..iterator])
	local box = CreateFrame("Editbox", "Editbox"..iterator, parent, "InputBoxTemplate")
	box:SetHeight(24)
	box.title = box:CreateFontString()
	box.title:SetPoint("RIGHT", box, "LEFT", -6,0)
	box.title:SetFontObject("GameFontHighlight")
	if withButton then
		box.accept = CreateFrame("Button", nil, parent, "UIPanelButtonTemplate")
		box.accept:SetPoint("LEFT", box, "RIGHT", 4, 0)
		box.accept:SetWidth(90)
		box.accept:SetHeight(24)
	end
	box:SetAutoFocus(false)
	box:ClearFocus()
	return box
end

function ScaleEverything:CreateFourWayButton(parent, width, height)
	local pad = CreateFrame("Frame", nil, parent)
	pad:SetWidth(width)
	pad:SetHeight(height)
	local selection = {"TOP", "RIGHT", "BOTTOM", "LEFT"}
	for i = 1, 4 do
	pad["button"..i] = CreateFrame("Button", nil, pad, "UIPanelButtonTemplate")
	pad["button"..i]:SetPoint(selection[i], pad, selection[i], 0, 0)
	pad["button"..i]:SetWidth(pad:GetWidth() / 3)
	pad["button"..i]:SetHeight(pad:GetHeight() / 3)
	end
	return pad
end

function ScaleEverything:CreateAdvancedPage()

	local advancedPanel = CreateFrame("Frame")
	advancedPanel.name = SE_GetLocaleString("ADVANCED_PAGE_NAME")
	advancedPanel.parent = SE_GetLocaleString("PAGE_NAME")

	local SE_title = advancedPanel:CreateFontString() 
	SE_title:SetFontObject(GameFontNormalLarge)
	SE_title:SetPoint("TOPLEFT", 16, -16)
	SE_title:SetText(SE_GetLocaleString("ADVANCED_PAGE_NAME"))

	local SE_subText = advancedPanel:CreateFontString()
	SE_subText:SetFontObject(GameFontHighlightSmall)
	SE_subText:SetPoint("TOPLEFT", SE_title, "BOTTOMLEFT", 0, -8)
	SE_subText:SetPoint("RIGHT", -30, 0)
	SE_subText:SetHeight(32)
	SE_subText:SetJustifyH("LEFT")
	SE_subText:SetJustifyV("TOP")
	SE_subText:SetText(SE_GetLocaleString("ADVANCED_PAGE_DESCRIPTION"))  
	
	local frameName = ScaleEverything:CreateEditBox(advancedPanel, true)
	local positionating = ScaleEverything:CreateFourWayButton(advancedPanel, 92, 64)
	local offsetX = ScaleEverything:CreateEditBox(advancedPanel)
	local offsetY = ScaleEverything:CreateEditBox(advancedPanel)
	local scale = ScaleEverything:CreateSlider(advancedPanel, "Skalierung", true)
	local scaleBox = ScaleEverything:CreateEditBox(advancedPanel)
	
	frameName:SetPoint("TOP", SE_subText,"BOTTOM", 0, -4)
	frameName:SetWidth(170)
	frameName:SetScript("OnEnterPressed", function(self)
		if type(getglobal(self:GetText())) == "table" then
			TOMOVE = getglobal(self:GetText())
			offsetX:SetText(select(4, TOMOVE:GetPoint()))
			offsetY:SetText(select(5, TOMOVE:GetPoint()))
			offsetX:SetCursorPosition(0)
			offsetY:SetCursorPosition(0)
			scale.frame = frameName:GetText()
			scale:SetValue(TOMOVE:GetScale())
		end
		self:ClearFocus()
	end)
	
	frameName.title:SetText("Framename")
	
	frameName.accept:SetText(SE_GetLocaleString("ADVANCED_PAGE_ACCEPT"))
	frameName.accept:SetScript("OnClick", function(self)
		if type(getglobal(frameName:GetText())) == "table" then
			TOMOVE = getglobal(frameName:GetText())
			offsetX:SetText(select(4, TOMOVE:GetPoint()))
			offsetY:SetText(select(5, TOMOVE:GetPoint()))
			offsetX:SetCursorPosition(0)
			offsetY:SetCursorPosition(0)
			scale.frame = frameName:GetText()
			if SCALETABLE[scale.frame] ~= "NA" then
				scale:SetValue(TOMOVE:GetScale())
				scale:Show()
				scaleBox:Show()
			else
				scale:Hide()
				scaleBox:Hide()
			end
		end
		frameName:ClearFocus()		
	end)
	
	positionating.button1:SetText("^")
	positionating.button2:SetText(">")
	positionating.button3:SetText("v")
	positionating.button4:SetText("<")
	
	positionating:SetPoint("TOP", frameName, "BOTTOM", 0, -10)
	positionating:SetPoint("RIGHT", -30, 0)
	
	offsetX.title:SetText("Offset X")
	offsetX:SetPoint("TOPRIGHT", positionating, "BOTTOMRIGHT", 0, -8)
	offsetX:SetWidth(60)
	
	offsetY.title:SetText("Offset Y")
	offsetY:SetPoint("TOP", offsetX, "BOTTOM", 0, -4)
	offsetY:SetWidth(60)
	
	scale:SetPoint("TOPLEFT", frameName, "BOTTOMLEFT", 0, -10)
	scale:SetWidth(80)
	scale.caption:SetWidth(60)
	scale:SetMinMaxValues(0.1, 2)
	scale:SetValue(1)
	scale:EnableMouseWheel(true)
	getglobal(scale:GetName().."Low"):SetFormattedText("%.2f",scale:GetMinMaxValues())
	getglobal(scale:GetName().."High"):SetFormattedText("%.2f",select(2,scale:GetMinMaxValues()))
	
	scaleBox:SetPoint("LEFT", scale, "RIGHT", 10, 0)
	scaleBox:SetWidth(40)
	scaleBox:SetHeight(scale:GetHeight())
	
	scaleBox:SetScript("OnEnterPressed", function(self)
		if type(TOMOVE) == "table" and tonumber(scaleBox:GetText()) then
			if SCALETABLE[TOMOVE:GetName()] ~= "NA" then
				TOMOVE:SetScale(scaleBox:GetText())
				SCALETABLE[TOMOVE:GetName()] = scaleBox:GetText()
				scale:SetValue(scaleBox:GetText())
			end
		end
	end)
	
	offsetX:SetScript("OnEnterPressed", function(self)
		if type(TOMOVE) == "table" then
			local anchor, relative, relativeto, offsetx, offsety = TOMOVE:GetPoint()
			if type(relative) == "table" then
				relative = relative:GetName()
			else
				relative = TOMOVE:GetParent():GetName()
			end
			TOMOVE:ClearAllPoints()
			if TOMOVE.orgPoint then
				TOMOVE:orgPoint(anchor, relative, relativeto, self:GetText(), offsety)
			else
				TOMOVE:SetPoint(anchor, relative, relativeto, self:GetText(), offsety)
			end
			POINTTABLE[TOMOVE:GetName()] = { anchor, relative, relativeto, self:GetText(), offsety }
			end
		self:ClearFocus()
	end)

	offsetY:SetScript("OnEnterPressed", function(self)
		if type(TOMOVE) == "table" then
			local anchor, relative, relativeto, offsetx, offsety = TOMOVE:GetPoint()
			if type(relative) == "table" then
				relative = relative:GetName()
			else
				relative = TOMOVE:GetParent():GetName()
			end
			TOMOVE:ClearAllPoints()
			if TOMOVE.orgPoint then
				TOMOVE:orgPoint(anchor, relative, relativeto, offsetx, self:GetText())
			else
				TOMOVE:SetPoint(anchor, relative, relativeto, offsetx, self:GetText())
			end
			POINTTABLE[TOMOVE:GetName()] = { anchor, relative, relativeto, offsetx, self:GetText() }
		end
		self:ClearFocus()
	end)
	
	positionating.button1:SetScript("OnMousedown", function(self, button)
		if type(TOMOVE) == "table" then
			local anchor, relative, relativeto, offsetx, offsety = TOMOVE:GetPoint()
			if type(relative) == "table" then
				relative = relative:GetName()
			else
				relative = TOMOVE:GetParent():GetName()
			end
			TOMOVE:ClearAllPoints()
			if TOMOVE.orgPoint then
				TOMOVE:orgPoint(anchor, relative, relativeto, offsetx, offsety+1)
			else
				TOMOVE:SetPoint(anchor, relative, relativeto, offsetx, offsety+1)
			end
			offsetY:SetText(offsety+1)
			offsetY:SetCursorPosition(0)
			POINTTABLE[TOMOVE:GetName()] = { anchor, relative, relativeto, offsetx, offsety+1 }
		end
	end)

	positionating.button2:SetScript("OnMousedown", function(self, button)
		if type(TOMOVE) == "table" then
			local anchor, relative, relativeto, offsetx, offsety = TOMOVE:GetPoint()
			if type(relative) == "table" then
				relative = relative:GetName()
			else
				relative = TOMOVE:GetParent():GetName()
			end
			TOMOVE:ClearAllPoints()
			if TOMOVE.orgPoint then
				TOMOVE:orgPoint(anchor, relative, relativeto, offsetx+1, offsety)
			else
				TOMOVE:SetPoint(anchor, relative, relativeto, offsetx+1, offsety)
			end
			offsetX:SetText(offsetx+1)
			offsetX:SetCursorPosition(0)
			POINTTABLE[TOMOVE:GetName()] = { anchor, relative, relativeto, offsetx+1, offsety }
		end
	end)
	
	positionating.button3:SetScript("OnMousedown", function(self, button)
		if type(TOMOVE) == "table" then
			local anchor, relative, relativeto, offsetx, offsety = TOMOVE:GetPoint()
			if type(relative) == "table" then
				relative = relative:GetName()
			else
				relative = TOMOVE:GetParent():GetName()
			end
			TOMOVE:ClearAllPoints()
			if TOMOVE.orgPoint then
				TOMOVE:orgPoint(anchor, relative, relativeto, offsetx, offsety-1)
			else
				TOMOVE:SetPoint(anchor, relative, relativeto, offsetx, offsety-1)
			end
			offsetY:SetText(offsety-1)
			offsetY:SetCursorPosition(0)
			POINTTABLE[TOMOVE:GetName()] = { anchor, relative, relativeto, offsetx, offsety-1 }
		end
	end)
	
	positionating.button4:SetScript("OnMousedown", function(self, button)
		if type(TOMOVE) == "table" then
			local anchor, relative, relativeto, offsetx, offsety = TOMOVE:GetPoint()
			if type(relative) == "table" then
				relative = relative:GetName()
			else
				relative = TOMOVE:GetParent():GetName()
			end
			TOMOVE:ClearAllPoints()
			if TOMOVE.orgPoint then
				TOMOVE:orgPoint(anchor, relative, relativeto, offsetx-1, offsety)
			else
				TOMOVE:SetPoint(anchor, relative, relativeto, offsetx-1, offsety)
			end
			offsetX:SetText(offsetx-1)
			offsetX:SetCursorPosition(0)
			POINTTABLE[TOMOVE:GetName()] = { anchor, relative, relativeto, offsetx-1, offsety }
		end
	end)
	
	scale:SetScript("OnMouseWheel", function(self, arg1)
		scale:SetValue(scale:GetValue() +( arg1 / 100))	
	end)

	scale:SetScript("OnValueChanged", function(self)
		if type(TOMOVE) == "table" and SCALETABLE[self.frame] ~= "NA" then
			SCALETABLE[self.frame] = self:GetValue()
			GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
			GameTooltip:SetText(string.format(SE_GetLocaleString("TOOLTIP_SCALE"), self.frame, SCALETABLE[self.frame]*100))
			GameTooltip:Show()
			scaleBox:SetText(self:GetValue())
			scaleBox:SetCursorPosition(0)
			if getglobal(self.frame).orgScale then
				getglobal(self.frame):orgScale(self:GetValue())
			else
				getglobal(self.frame):SetScale(self:GetValue())
			end
		end
	end)

	scale:SetScript("OnEnter", function(self)
		if type(TOMOVE) == "table" and SCALETABLE[self.frame] ~= "NA" then
			GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
			GameTooltip:SetText(string.format(SE_GetLocaleString("TOOLTIP_SCALE"), (self.frame or ""), SCALETABLE[self.frame]*100))
			GameTooltip:Show()
		end
	end)

	scale:SetScript("OnLeave", function(self)
		GameTooltip:ClearLines()
		GameTooltip:Hide()
	end)

	advancedPanel.default = function()
	end

	advancedPanel.cancel = function()
	end

	advancedPanel.okay = function()
	end

	InterfaceOptions_AddCategory(advancedPanel)  

end 